#include "adc_conf.h"

void adc_conf(){

	/* GPIO configuration - input on PB0 */
	GPIO_InitTypeDef GPIO_InitStructure;

	/* Enable GPIOB clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

	/* Configure PB0 (ADC Channel8) as analog input */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	

	/* ADC1 configuration */
	ADC_InitTypeDef ADC_InitStructure;

	/* ADC clock must be 14 MHz or less */
	RCC_ADCCLKConfig(RCC_PCLK2_Div6); 

	/* Enable ADC1 clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);

	/* ADC1 configuration */
	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;
	ADC_InitStructure.ADC_ScanConvMode = DISABLE;
	ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
	ADC_InitStructure.ADC_NbrOfChannel = 1;
	ADC_Init(ADC1, &ADC_InitStructure);


	/* Enable ADC1 */
	ADC_Cmd(ADC1, ENABLE);
    
}


uint16_t readADC(uint8_t channel){

	/* ADC1 regular channel14 configuration */ 
	ADC_RegularChannelConfig(ADC1, channel, 1, ADC_SampleTime_55Cycles5);

	/* Enable ADC1 reset calibration register */   
	ADC_ResetCalibration(ADC1);
	/* Check the end of ADC1 reset calibration register */
	while(ADC_GetResetCalibrationStatus(ADC1));

	/* Start ADC1 calibration */
	ADC_StartCalibration(ADC1);
	/* Check the end of ADC1 calibration */
	while(ADC_GetCalibrationStatus(ADC1));

	/* Start conversion */
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);
	
	/* Wait until conversion complete */
	while(ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC) == RESET);

	/* Return ADC->DR */
	return ADC_GetConversionValue(ADC1);
}



